Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientManager.cs	(revision 3022)
@@ -1,3 +1,4 @@
 #region License Information
+
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -18,4 +19,5 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
+
 #endregion
 
@@ -33,12 +35,8 @@
 
 namespace HeuristicLab.Hive.Server.Core {
-  class ClientManager: IClientManager {
-    
-    //ISessionFactory factory;
-    List<ClientGroup> clientGroups;
+  internal class ClientManager : IClientManager {
+    private List<ClientGroup> clientGroups;
 
     public ClientManager() {
-      //factory = ServiceLocator.GetSessionFactory();
-      
       clientGroups = new List<ClientGroup>();
     }
@@ -51,23 +49,11 @@
     /// <returns></returns>
     public ResponseList<ClientDto> GetAllClients() {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
-
-        ResponseList<ClientDto> response = new ResponseList<ClientDto>();
-
-        response.List = new List<ClientDto>(DaoLocator.ClientDao.FindAll());
-        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTS;
-        response.Success = true;
-
-        return response;
-      /*}
-      finally {
-        if (session != null)
-          session.EndSession();
-      }*/
+      ResponseList<ClientDto> response = new ResponseList<ClientDto>();
+
+      response.List = new List<ClientDto>(DaoLocator.ClientDao.FindAll());
+      response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTS;
+      response.Success = true;
+
+      return response;
     }
 
@@ -77,34 +63,23 @@
     /// <returns></returns>
     public ResponseList<ClientGroup> GetAllClientGroups() {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
-        ResponseList<ClientGroup> response = new ResponseList<ClientGroup>();
-
-        List<ClientGroup> allClientGroups = new List<ClientGroup>(DaoLocator.ClientGroupDao.FindAllWithSubGroupsAndClients());
-        ClientGroup emptyClientGroup = new ClientGroup();
-        IEnumerable<ClientDto> groupLessClients = DaoLocator.ClientDao.FindAllClientsWithoutGroup();
-        if (groupLessClients != null) {
-          foreach (ClientDto currClient in groupLessClients) {
-            emptyClientGroup.Resources.Add(currClient);
-          }
+      ResponseList<ClientGroup> response = new ResponseList<ClientGroup>();
+
+      List<ClientGroup> allClientGroups =
+        new List<ClientGroup>(DaoLocator.ClientGroupDao.FindAllWithSubGroupsAndClients());
+      ClientGroup emptyClientGroup = new ClientGroup();
+      IEnumerable<ClientDto> groupLessClients = DaoLocator.ClientDao.FindAllClientsWithoutGroup();
+      if (groupLessClients != null) {
+        foreach (ClientDto currClient in groupLessClients) {
+          emptyClientGroup.Resources.Add(currClient);
         }
-        emptyClientGroup.Id = Guid.Empty;
-        allClientGroups.Add(emptyClientGroup);
-
-        response.List = allClientGroups;
-        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTGROUPS;
-        response.Success = true;
-
-        return response;
-   /*   }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }*/
+      }
+      emptyClientGroup.Id = Guid.Empty;
+      allClientGroups.Add(emptyClientGroup);
+
+      response.List = allClientGroups;
+      response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_ALL_CLIENTGROUPS;
+      response.Success = true;
+
+      return response;
     }
 
@@ -121,29 +96,19 @@
     /// <returns></returns>
     public ResponseObject<ClientGroup> AddClientGroup(ClientGroup clientGroup) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
-
-        ResponseObject<ClientGroup> response = new ResponseObject<ClientGroup>();
-
-        if (clientGroup.Id != Guid.Empty) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_ID_MUST_NOT_BE_SET;
-        } else {
-          clientGroup = DaoLocator.ClientGroupDao.Insert(clientGroup);
-          //clientGroupAdapter.Update(clientGroup);
-          response.Obj = clientGroup;
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_ADDED;
-        }
-
-        return response;
-      /*}
-      finally {
-        if (session != null)
-          session.EndSession();
-      } */
+      ResponseObject<ClientGroup> response = new ResponseObject<ClientGroup>();
+
+      if (clientGroup.Id != Guid.Empty) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_ID_MUST_NOT_BE_SET;
+      }
+      else {
+        clientGroup = DaoLocator.ClientGroupDao.Insert(clientGroup);
+        //clientGroupAdapter.Update(clientGroup);
+        response.Obj = clientGroup;
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_ADDED;
+      }
+
+      return response;
     }
 
@@ -155,134 +120,100 @@
     /// <returns></returns>
     public Response AddResourceToGroup(Guid clientGroupId, ResourceDto resource) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
-
-        Response response = new Response();
-
-        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
-        if (clientGroup == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
+      Response response = new Response();
+
+      ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
+      if (clientGroup == null) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
+        return response;
+      }
+      clientGroup.Resources.Add(resource);
+      DaoLocator.ClientGroupDao.AddRessourceToClientGroup(resource.Id, clientGroup.Id);
+      //clientGroupAdapter.Update(clientGroup);
+
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_ADDED_TO_GROUP;
+
+      return response;
+    }
+
+    /// <summary>
+    /// Remove a resource from a group
+    /// </summary>
+    /// <param name="clientGroupId"></param>
+    /// <param name="resourceId"></param>
+    /// <returns></returns>
+    public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
+      Response response = new Response();
+
+      ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
+      if (clientGroup == null) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
+        return response;
+      }
+      foreach (ResourceDto resource in clientGroup.Resources) {
+        if (resource.Id == resourceId) {
+          clientGroup.Resources.Remove(resource);
+          DaoLocator.ClientGroupDao.RemoveRessourceFromClientGroup(resource.Id, clientGroup.Id);
+          //clientGroupAdapter.Update(clientGroup);
+          response.Success = true;
+          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_REMOVED;
           return response;
         }
-        clientGroup.Resources.Add(resource);
-        DaoLocator.ClientGroupDao.AddRessourceToClientGroup(resource.Id, clientGroup.Id);          
-        //clientGroupAdapter.Update(clientGroup);
-
+      }
+      response.Success = false;
+      response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND;
+
+      return response;
+    }
+
+    public ResponseObject<List<ClientGroup>> GetAllGroupsOfResource(Guid resourceId) {
+      ResponseObject<List<ClientGroup>> response = new ResponseObject<List<ClientGroup>>();
+
+      ClientDto client = DaoLocator.ClientDao.FindById(resourceId);
+      if (client != null) {
+        List<ClientGroup> groupsOfClient = new List<ClientGroup>(DaoLocator.ClientGroupDao.MemberOf(client));
+        response.Obj = groupsOfClient;
         response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_ADDED_TO_GROUP;
-
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_GROUPS_OF_CLIENT;
+      }
+      else {
+        response.Obj = new List<ClientGroup>();
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND;
+      }
+
+      return response;
+    }
+
+    public Response DeleteClientGroup(Guid clientGroupId) {
+      Response response = new Response();
+
+      ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
+      if (clientGroup == null) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
         return response;
       }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      } 
-    }   */
-
-    /// <summary>
-    /// Remove a resource from a group
-    /// </summary>
-    /// <param name="clientGroupId"></param>
-    /// <param name="resourceId"></param>
-    /// <returns></returns>
-    public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
-
-        Response response = new Response();
-
-        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
-        if (clientGroup == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
-          return response;
-        }
-        foreach (ResourceDto resource in clientGroup.Resources) {
-          if (resource.Id == resourceId) {
-            clientGroup.Resources.Remove(resource);
-            DaoLocator.ClientGroupDao.RemoveRessourceFromClientGroup(resource.Id, clientGroup.Id);
-            //clientGroupAdapter.Update(clientGroup);
-            response.Success = true;
-            response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_REMOVED;
-            return response;
-          }
-        }
-        response.Success = false;
-        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND;
-
-        return response;
-      }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }   */
-
-    public ResponseObject<List<ClientGroup>> GetAllGroupsOfResource(Guid resourceId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
-        IClientAdapter clientAdapter =
-          session.GetDataAdapter<ClientDto, IClientAdapter>();*/
-
-        ResponseObject<List<ClientGroup>> response = new ResponseObject<List<ClientGroup>>();
-
-        ClientDto client = DaoLocator.ClientDao.FindById(resourceId);
-        if (client != null) {
-          List<ClientGroup> groupsOfClient = new List<ClientGroup>(DaoLocator.ClientGroupDao.MemberOf(client));
-          response.Obj = groupsOfClient;
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_GET_GROUPS_OF_CLIENT;
-        } else {
-          response.Obj = new List<ClientGroup>();
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND;
-        }
-
-        return response;
-      }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }   */
-
-    public Response DeleteClientGroup(Guid clientGroupId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IClientGroupAdapter clientGroupAdapter =
-          session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();*/
-
-        Response response = new Response();
-
-        ClientGroup clientGroup = DaoLocator.ClientGroupDao.FindById(clientGroupId);
-        if (clientGroup == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST;
-          return response;
-        }
-
-        DaoLocator.ClientGroupDao.Delete(clientGroup);
-
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DELETED;
-        return response;
-
-      }/* finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }    */
-
+
+      DaoLocator.ClientGroupDao.Delete(clientGroup);
+
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DELETED;
+      return response;
+    }
+
+    public ResponseList<AppointmentDto> GetUptimeCalendarForResource(Guid guid) {
+      ResponseList<AppointmentDto> response = new ResponseList<AppointmentDto>();
+      response.List = new List<AppointmentDto>(DaoLocator.UptimeCalendarDao.GetUptimeCalendarForResource(guid));
+      response.Success = true;
+      return response;
+    }
+
+    public Response SetUptimeCalendarForResource(Guid guid, IEnumerable<AppointmentDto> appointments) {
+      DaoLocator.UptimeCalendarDao.SetUptimeCalendarForResource(guid, appointments);
+      return new Response {Success = true};
+    }
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DaoLocator.cs	(revision 3022)
@@ -13,4 +13,5 @@
     [ThreadStatic] private static IJobDao jobDao;
     [ThreadStatic] private static IPluginInfoDao pluginInfoDao;
+    [ThreadStatic] private static IUptimeCalendarDao uptimeCalendarDao;
 
     public static IClientDao ClientDao {
@@ -54,4 +55,12 @@
     }
 
+    public static IUptimeCalendarDao UptimeCalendarDao {
+      get {
+        if (uptimeCalendarDao == null)
+          uptimeCalendarDao = new UptimeCalendarDao();
+        return uptimeCalendarDao;
+      }
+    }
+
     public static void DestroyContext() {
       if (ContextFactory.Context != null) {
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 3022)
@@ -172,4 +172,11 @@
     }
 
+    public ResponseList<AppointmentDto> GetUptimeCalendarForResource(Guid guid) {
+      return clientManager.GetUptimeCalendarForResource(guid);
+    }
+
+    public Response SetUptimeCalendarForResource(Guid guid, IEnumerable<AppointmentDto> appointments) {
+      return clientManager.SetUptimeCalendarForResource(guid, appointments);
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/HeuristicLab.Hive.Server.DataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/HeuristicLab.Hive.Server.DataAccess-3.2.csproj	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/HeuristicLab.Hive.Server.DataAccess-3.2.csproj	(revision 3022)
@@ -85,4 +85,5 @@
     <Compile Include="IPluginInfoDao.cs" />
     <Compile Include="IProjectAdapter.cs" />
+    <Compile Include="IUptimeCalendarDao.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="HiveServerDataAccessPlugin.cs" />
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IUptimeCalendarDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IUptimeCalendarDao.cs	(revision 3022)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IUptimeCalendarDao.cs	(revision 3022)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IUptimeCalendarDao: IGenericDao<AppointmentDto> {
+    IEnumerable<AppointmentDto> GetUptimeCalendarForResource(Guid resourceId);
+    void SetUptimeCalendarForResource(Guid resourceId, IEnumerable<AppointmentDto> appointments);
+    
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3022)
@@ -105,4 +105,5 @@
       <DependentUpon>Settings.settings</DependentUpon>
     </Compile>
+    <Compile Include="UptimeCalendarDao.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3022)
@@ -77,4 +77,5 @@
       <Association Name="Resource_ClientGroup_Resource" Member="ClientGroup_Resources" ThisKey="ResourceId" OtherKey="ResourceId" Type="ClientGroup_Resource" />
       <Association Name="Resource_Client" Member="Client" ThisKey="ResourceId" OtherKey="ResourceId" Type="Client" Cardinality="One" />
+      <Association Name="Resource_UptimeCalendar" Member="UptimeCalendars" ThisKey="ResourceId" OtherKey="ResourceId" Type="UptimeCalendar" />
     </Type>
   </Table>
@@ -120,3 +121,15 @@
     </Type>
   </Table>
+  <Table Name="dbo.UptimeCalendar" Member="UptimeCalendars">
+    <Type Name="UptimeCalendar">
+      <Column Name="UptimeCalendarId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
+      <Column Name="ResourceId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" CanBeNull="false" />
+      <Column Name="StartDate" Type="System.DateTime" DbType="DateTime NOT NULL" CanBeNull="false" />
+      <Column Name="EndDate" Type="System.DateTime" DbType="DateTime NOT NULL" CanBeNull="false" />
+      <Column Name="AllDayEvent" Type="System.Boolean" DbType="Bit NOT NULL" CanBeNull="false" />
+      <Column Name="Recurring" Type="System.Boolean" DbType="Bit NOT NULL" CanBeNull="false" />
+      <Column Name="RecurringId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
+      <Association Name="Resource_UptimeCalendar" Member="Resource" ThisKey="ResourceId" OtherKey="ResourceId" Type="Resource" IsForeignKey="true" DeleteRule="CASCADE" DeleteOnNull="true" />
+    </Type>
+  </Table>
 </Database>
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3021)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3022)
@@ -71,5 +71,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.4375 : 5.75); (4.4375 : 5.1362939453125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(4.78125 : 5.75); (4.78125 : 5.1362939453125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Resource/Resource_AssignedResource" />
       <nodes>
@@ -105,5 +105,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.5 : 6.94399251302083); (4.5 : 7.625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(4.78125 : 6.94399251302083); (4.78125 : 7.625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Resource/Resource_Client" />
       <nodes>
@@ -125,5 +125,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(10 : 6.5); (10 : 4.34375); (5.5 : 4.34375)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(10 : 6.5); (10 : 4.34375); (5.5 : 4.34375)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Job/Job_AssignedResource" />
       <nodes>
@@ -132,5 +132,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(11 : 9.37580485026042); (12 : 9.37580485026042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(11 : 9.37580485026042); (12 : 9.37580485026042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Job/Job_RequiredPlugin" />
       <nodes>
@@ -139,5 +139,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(5.625 : 8.91270182291667); (9 : 8.91270182291667)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(5.625 : 8.91270182291667); (9 : 8.91270182291667)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Client/Client_Job" />
       <nodes>
@@ -153,5 +153,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(8.25 : 11.0969962565104); (9.32336288461538 : 11.0969962565104); (9.32336288461538 : 10.0016097005208)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(8.25 : 11.0969962565104); (9.32336288461538 : 11.0969962565104); (9.32336288461538 : 10.0016097005208)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Project/Project_Job" />
       <nodes>
@@ -160,4 +160,17 @@
       </nodes>
     </associationConnector>
+    <classShape Id="9ae82b5f-6e47-4a8e-8350-f7312381bb3b" absoluteBounds="0.625, 5.125, 2, 2.1554996744791666">
+      <DataClassMoniker Name="/HiveDataContext/UptimeCalendar" />
+      <nestedChildShapes>
+        <elementListCompartment Id="7469c6a3-4cb2-41c2-82b9-6999782218dd" absoluteBounds="0.64000000000000012, 5.585, 1.9700000000000002, 1.5954996744791665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <associationConnector edgePoints="[(3.375 : 6.34699625651042); (2.625 : 6.34699625651042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/HiveDataContext/Resource/Resource_UptimeCalendar" />
+      <nodes>
+        <classShapeMoniker Id="e44e8355-4290-42f0-8b46-4473e91e504b" />
+        <classShapeMoniker Id="9ae82b5f-6e47-4a8e-8350-f7312381bb3b" />
+      </nodes>
+    </associationConnector>
   </nestedChildShapes>
 </ordesignerObjectsDiagram>
